// TwoFactorPde.hpp
//
// Generic convection-diffusion-reaction 2d Pde using Boost. 
//
// (C) Datasim Education BV 2009-2010
//

#ifndef TwoFactorPde_hpp
#define TwoFactorPde_hpp

#include <boost/function.hpp>

template <typename T> class TwoFactorPde
{
public:

		// Functions are public because we may need to semi-discretise in conjunction
		// with Bind

		// U_t = a11U_xx + a22U_yy + b1U_x + b2U_y + cU_xy + dU + F; // f = f(x,y,t)
		boost::function<T (T,T,T)> a11;
		boost::function<T (T,T,T)> a22;
		boost::function<T (T,T,T)> c;
		boost::function<T (T,T,T)> b1;
		boost::function<T (T,T,T)> b2;
		boost::function<T (T,T,T)> d;
		boost::function<T (T,T,T)> F;

		TwoFactorPde() {} 
	
};

#endif